<?php
/*------------------------------------------------------------------------------
     The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is fun_list.php, released on 2003-03-31.

     The Initial Developer of the Original Code is The QuiX project.

     Alternatively, the contents of this file may be used under the terms
     of the GNU General Public License Version 2 or later (the "GPL"), in
     which case the provisions of the GPL are applicable instead of
     those above. If you wish to allow use of your version of this file only
     under the terms of the GPL and not to allow others to use
     your version of this file under the MPL, indicate your decision by
     deleting  the provisions above and replace  them with the notice and
     other provisions required by the GPL.  If you do not delete
     the provisions above, a recipient may use your version of this file
     under either the MPL or the GPL."
------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------
Author: The QuiX project
	quix@free.fr
	http://www.quix.tk
	http://quixplorer.sourceforge.net

Comment:
	QuiXplorer Version 2.3
	Directory-Listing Functions
	
	Have Fun...
------------------------------------------------------------------------------*/
function getLabel($abs_item) {
 $sal="";
 $thecreds="";
		$id=dba_open($GLOBALS["dbfile"],"r","db4");
		if ($id > 0)
		{
			// Ahora hemos de comprobar si el password es vacio o no
                	if (dba_exists($abs_item,$id))
			{
				$dbline=dba_fetch($abs_item,$id);
				list ($ipDBA,$pass2,$labelDBA,$thecreds) = explode ("/", $dbline);
                                $sal=$labelDBA;
			}
                	dba_close($id);
		}
  return( $sal);
}

//------------------------------------------------------------------------------
// HELPER FUNCTIONS (USED BY MAIN FUNCTION 'list_dir', SEE BOTTOM)
function make_list($_list1, $_list2) {		// make list of files
	$list="";
	if($GLOBALS["srt"]=="yes") {
		$list1 = $_list1;
		$list2 = $_list2;
	} else {
		$list1 = $_list2;
		$list2 = $_list1;
	}
	
	if(is_array($list1)) {
		while (list($key, $val) = each($list1)) {
			$list[$key] = $val;
		}
	}
	
	if(is_array($list2)) {
		while (list($key, $val) = each($list2)) {
			$list[$key] = $val;
		}
	}
	
	return $list;
}
//------------------------------------------------------------------------------
function make_tables($dir, &$dir_list, &$file_list, &$tot_file_size, &$num_items)
{						// make table of files in dir
	// make tables & place results in reference-variables passed to function
	// also 'return' total filesize & total number of items
	
	$tot_file_size = $num_items = 0;
	
	// Open directory
	$handle = @opendir(get_abs_dir($dir));
	if($handle===false) show_error($dir.": ".$GLOBALS["error_msg"]["opendir"]);
	
	// Read directory
	while(($new_item = readdir($handle))!==false) {
		$abs_new_item = get_abs_item($dir, $new_item);
		
		if(!@file_exists($abs_new_item)) show_error($dir.": ".$GLOBALS["error_msg"]["readdir"]);
		if(!get_show_item($dir, $new_item)) continue;
		
		$new_file_size = filesize($abs_new_item);
		$tot_file_size += $new_file_size;
		$num_items++;
		
		if(get_is_dir($dir, $new_item)) {
			if($GLOBALS["order"]=="mod") {
				$dir_list[$new_item] =
					@filemtime($abs_new_item);
			} else {	// order == "size", "type" or "name"
				$dir_list[$new_item] = $new_item;
			}
		} else {
			if($GLOBALS["order"]=="size") {
				$file_list[$new_item] = $new_file_size;
			} elseif($GLOBALS["order"]=="mod") {
				$file_list[$new_item] =
					@filemtime($abs_new_item);
			} elseif($GLOBALS["order"]=="type") {
				$file_list[$new_item] =
					get_mime_type($dir, $new_item, "type");
			} elseif($GLOBALS["order"]=="label") {
				$file_list[$new_item] = getLabel( $abs_new_item);
			} else {	// order == "name"
				$file_list[$new_item] = $new_item;
			}
		}
	}
	closedir($handle);
	
	
	// sort
	if(is_array($dir_list)) {
		if($GLOBALS["order"]=="mod") {
			if($GLOBALS["srt"]=="yes") arsort($dir_list);
			else asort($dir_list);
		} else {	// order == "size", "type" or "name"
			if($GLOBALS["srt"]=="yes") ksort($dir_list);
			else krsort($dir_list);
		}
	}
	
	// sort
	if(is_array($file_list)) {
		if($GLOBALS["order"]=="mod") {
			if($srt=="yes") arsort($file_list);
			else asort($file_list);
		} elseif($GLOBALS["order"]=="size" || $GLOBALS["order"]=="type" || $GLOBALS["order"]=="label") {
			if($GLOBALS["srt"]=="yes") asort($file_list);
			else arsort($file_list);
		} else {	// order == "name"
			if($GLOBALS["srt"]=="yes") ksort($file_list);
			else krsort($file_list);
		}
	}
}
//------------------------------------------------------------------------------
function print_table($dir, $list, $allow) {	// print table of files
  $thecreds="";
	if(!is_array($list)) return;
	
	while(list($item,) = each($list)){
		// link to dir / file
		$abs_item=get_abs_item($dir,$item);
		//$extra="";
		//if(is_link($abs_item)) $extra=" -> ".@readlink($abs_item);
		if(is_dir($abs_item)) {
			$link = make_link("list",get_rel_item($dir, $item),NULL);
		} else { //if(get_is_editable($dir,$item) || get_is_image($dir,$item)) {
//			$link = $GLOBALS["home_url"]."/".get_rel_item($dir, $item);
			$link = make_link("download",$dir,$item);
		} //else $link = "";
		
		echo "<TR class=\"rowdata\"><TD><INPUT TYPE=\"checkbox\" name=\"selitems[]\" value=\"";
		echo $item."\" onclick=\"javascript:Toggle(this);\"></TD>\n";

		//luism
		echo "<TD>";
		if( se_puede_download( $dir, $item)) {
		  echo "<IMG src='_img/luis/reddot.gif'>";
		} else {
		  echo "<IMG src='_img/luis/greendot.gif'>";
		}
		echo "</TD>";


		echo "<TD nowrap>";
		// Mostrar si el archivo esta protegido con password
		$id=dba_open($GLOBALS["dbfile"],"r","db4");
		$con_password=0;
		if ($id > 0)
		{
			// Ahora hemos de comprobar si el password es vacio o no
                	if (dba_exists($abs_item,$id))
			{
				$dbline=dba_fetch($abs_item,$id);
				list ($ipDBA,$pass2,$labelDBA,$thecreds) = explode ("/", $dbline);
				if (($pos=strpos($dbline,"/")) && (strlen($dbline) > ($pos+1)))
				{
					$con_password=1;
				}
			}
                	dba_close($id);
		}
	// Icon + Link
		/*if($link!="") */ 
			echo"<A HREF=\"".$link."\">";
		//else echo "<A>";
		echo "<IMG border=\"0\" width=\"16\" height=\"16\" ";
		echo "align=\"ABSMIDDLE\" src=\"_img/".get_mime_type($dir, $item, "img")."\" ALT=\"\">&nbsp;";
		$s_item=$item;	if(strlen($s_item)>50) $s_item=substr($s_item,0,47)."...";
		echo $s_item;
	if ($con_password==1)	
	{
				echo " <IMG border=\"0\" width=\"8\" height=\"11\" ";
				echo "align=\"ABSMIDDLE\" src=\"_img/candado.gif\" ALT=\"\">&nbsp;";				
	}
        if( $thecreds != "") {
          echo " Auth ";
        }
		echo "</A></TD>\n";	// ...$extra...
	
	// Label
		echo "<TD>".$labelDBA."</TD>\n";
	// Size
		echo "<TD>".parse_file_size(get_file_size($dir,$item))."</TD>\n";
	// Type
		echo "<TD>".get_mime_type($dir, $item, "type")."</TD>\n";
	// Modified
		echo "<TD>".parse_file_date(get_file_date($dir,$item))."</TD>\n";
	// Actions
		//echo "<TD>\n<TABLE>\n";
		// DOWNLOAD
		/*if(get_is_file($dir,$item)) {
			if($allow) {
				echo "<TD><A HREF=\"".make_link("download",$dir,$item)."\">";
				echo "<IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
				echo "src=\"_img/_download.gif\" ALT=\"".$GLOBALS["messages"]["downlink"];
				echo "\" TITLE=\"".$GLOBALS["messages"]["downlink"]."\"></A></TD>\n";
			} else if(!$allow) {
				echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
				echo "src=\"_img/_download_.gif\" ALT=\"".$GLOBALS["messages"]["downlink"];
				echo "\" TITLE=\"".$GLOBALS["messages"]["downlink"]."\"></TD>\n";
			}
		} else {
			echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
			echo "src=\"_img/_.gif\" ALT=\"\"></TD>\n";
		}*/
		//echo "</TABLE>\n</TD>";
		echo "</TR>\n";
	}
}
//------------------------------------------------------------------------------
// MAIN FUNCTION
function list_dir($dir) {			// list directory contents
	$allow=($GLOBALS["permissions"]&01)==01;
	$admin=((($GLOBALS["permissions"]&04)==04) || (($GLOBALS["permissions"]&02)==02));
	
	$dir_up = dirname($dir);
	if($dir_up==".") $dir_up = "";
	
	if(!get_show_item($dir_up,basename($dir))) show_error($dir." : ".$GLOBALS["error_msg"]["accessdir"]);
	
	// make file & dir tables, & get total filesize & number of items
	make_tables($dir, $dir_list, $file_list, $tot_file_size, $num_items);
	
	$s_dir=$dir;		if(strlen($s_dir)>50) $s_dir="...".substr($s_dir,-47);
	show_header($GLOBALS["messages"]["actdir"].": /".get_rel_item("",$s_dir));
	
	// Javascript functions:
	include "./.include/javascript.php";
	
	// Sorting of items
	$_img = "&nbsp;<IMG width=\"10\" height=\"10\" border=\"0\" align=\"ABSMIDDLE\" src=\"_img/";
	if($GLOBALS["srt"]=="yes") {
		$_srt = "no";	$_img .= "_arrowup.gif\" ALT=\"^\">";
	} else {
		$_srt = "yes";	$_img .= "_arrowdown.gif\" ALT=\"v\">";
	}
	
	// Toolbar
	echo "<BR><TABLE width=\"95%\"><TR><TD><TABLE><TR>\n";
	
	// RELOAD
	echo "<TD><A HREF=\"javascript:location.reload();\"><IMG border=\"0\" width=\"16\" height=\"16\" ";
	echo "align=\"ABSMIDDLE\" src=\"_img/_refresh.gif\" ALT=\"".$GLOBALS["messages"]["reloadlink"];
	echo "\" TITLE=\"".$GLOBALS["messages"]["reloadlink"]."\"></A></TD>\n";
	// SEARCH
	//echo "<TD><A HREF=\"".make_link("search",$dir,NULL)."\">";
	//echo "<IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" src=\"_img/_search.gif\" ";
	//echo "ALT=\"".$GLOBALS["messages"]["searchlink"]."\" TITLE=\"".$GLOBALS["messages"]["searchlink"];
	//echo "\"></A></TD>\n";
	//echo "<TD>::</TD>";
	
	if($allow) {
		// COPY
		echo "<TD><A HREF=\"javascript:Copy();\"><IMG border=\"0\" width=\"16\" height=\"16\" ";
		echo "align=\"ABSMIDDLE\" src=\"_img/_copy.gif\" ALT=\"".$GLOBALS["messages"]["copylink"];
		echo "\" TITLE=\"".$GLOBALS["messages"]["copylink"]."\"></A></TD>\n";
		// MOVE
		echo "<TD><A HREF=\"javascript:Move();\"><IMG border=\"0\" width=\"16\" height=\"16\" ";
		echo "align=\"ABSMIDDLE\" src=\"_img/_move.gif\" ALT=\"".$GLOBALS["messages"]["movelink"];
		echo "\" TITLE=\"".$GLOBALS["messages"]["movelink"]."\"></A></TD>\n";
		// DELETE
		echo "<TD><A HREF=\"javascript:Delete();\"><IMG border=\"0\" width=\"16\" height=\"16\" ";
		echo "align=\"ABSMIDDLE\" src=\"_img/_delete.gif\" ALT=\"".$GLOBALS["messages"]["dellink"];
		echo "\" TITLE=\"".$GLOBALS["messages"]["dellink"]."\"></A></TD>\n";
		// UPLOAD
		if(get_cfg_var("file_uploads")) {
			echo "<TD><A HREF=\"".make_link("upload",$dir,NULL)."\">";
			echo "<IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
			echo "src=\"_img/_upload.gif\" ALT=\"".$GLOBALS["messages"]["uploadlink"];
			echo "\" TITLE=\"".$GLOBALS["messages"]["uploadlink"]."\"></A></TD>\n";
		} else {
			echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
			echo "src=\"_img/_upload_.gif\" ALT=\"".$GLOBALS["messages"]["uploadlink"];
			echo "\" TITLE=\"".$GLOBALS["messages"]["uploadlink"]."\"></TD>\n";
		}
		// ARCHIVE
		if($GLOBALS["zip"] || $GLOBALS["tar"] || $GLOBALS["tgz"]) {
			echo "<TD><A HREF=\"javascript:Archive();\"><IMG border=\"0\" width=\"16\" height=\"16\" ";
			echo "align=\"ABSMIDDLE\" src=\"_img/_archive.gif\" ALT=\"".$GLOBALS["messages"]["comprlink"];
			echo "\" TITLE=\"".$GLOBALS["messages"]["comprlink"]."\"></A></TD>\n";
		}
	} else {
		// COPY
		echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
		echo "src=\"_img/_copy_.gif\" ALT=\"".$GLOBALS["messages"]["copylink"]."\" TITLE=\"";
		echo $GLOBALS["messages"]["copylink"]."\"></TD>\n";
		// MOVE
		echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
		echo "src=\"_img/_move_.gif\" ALT=\"".$GLOBALS["messages"]["movelink"]."\" TITLE=\"";
		echo $GLOBALS["messages"]["movelink"]."\"></TD>\n";
		// DELETE
		echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
		echo "src=\"_img/_delete_.gif\" ALT=\"".$GLOBALS["messages"]["dellink"]."\" TITLE=\"";
		echo $GLOBALS["messages"]["dellink"]."\"></TD>\n";
		// UPLOAD
		echo "<TD><IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
		echo "src=\"_img/_upload_.gif\" ALT=\"".$GLOBALS["messages"]["uplink"];
		echo "\" TITLE=\"".$GLOBALS["messages"]["uplink"]."\"></TD>\n";
	}
	
	// ADMIN & LOGOUT
	if($GLOBALS["require_login"]) {
		echo "<TD>::</TD>";
		// ADMIN
		if($admin) {
			echo "<TD><A HREF=\"".make_link("admin",$dir,NULL)."\">";
			echo "<IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
			echo "src=\"_img/_admin.gif\" ALT=\"".$GLOBALS["messages"]["adminlink"]."\" TITLE=\"";
			echo $GLOBALS["messages"]["adminlink"]."\"></A></TD>\n";
		}
		// LOGOUT
		echo "<TD><A HREF=\"".make_link("logout",NULL,NULL)."\">";
		echo "<IMG border=\"0\" width=\"16\" height=\"16\" align=\"ABSMIDDLE\" ";
		echo "src=\"_img/_logout.gif\" ALT=\"".$GLOBALS["messages"]["logoutlink"]."\" TITLE=\"";
		echo $GLOBALS["messages"]["logoutlink"]."\"></A></TD>\n";
	}
        echo "</TR></TABLE></TD>\n";
                        
        echo "</TR></TABLE>\n";

	// End Toolbar
	
	
	// Begin Table + Form for checkboxes
	echo"<TABLE WIDTH=\"95%\"><FORM name=\"selform\" method=\"POST\" action=\"".make_link("post",$dir,NULL)."\">\n";
	echo "<INPUT type=\"hidden\" name=\"do_action\"><INPUT type=\"hidden\" name=\"first\" value=\"y\">\n";
	
	// Table Header
	echo "<TR><TD colspan=\"7\"><HR></TD></TR><TR><TD WIDTH=\"2%\" class=\"header\">\n";
	echo "<INPUT TYPE=\"checkbox\" name=\"toggleAllC\" onclick=\"javascript:ToggleAll(this);\"></TD>\n";

        //luism
        echo "<TD  WIDTH=\"1%\" class=\"header\">";
 	echo "&nbsp;";
        echo "</TD>";

	echo "<TD WIDTH=\"42%\" class=\"header\"><B>\n";
	if($GLOBALS["order"]=="name") $new_srt = $_srt;	else $new_srt = "yes";
	echo "<A href=\"".make_link("list",$dir,NULL,"name",$new_srt)."\">".$GLOBALS["messages"]["nameheader"];
	if($GLOBALS["order"]=="name") echo $_img;
	echo "</A></B></TD>\n<TD WIDTH=\"10%\" class=\"header\"><B>";

	
	if($GLOBALS["order"]=="label") $new_srt = $_srt; else $new_srt = "yes";
	echo "<A href=\"".make_link("list",$dir,NULL,"label",$new_srt)."\">".$GLOBALS["messages"]["labelheader"];
	if($GLOBALS["order"]=="label") echo $_img;
	echo "</A></B></TD>\n<TD WIDTH=\"10%\" class=\"header\"><B>";
	

	if($GLOBALS["order"]=="size") $new_srt = $_srt;	else $new_srt = "yes";
	echo "<A href=\"".make_link("list",$dir,NULL,"size",$new_srt)."\">".$GLOBALS["messages"]["sizeheader"];
	if($GLOBALS["order"]=="size") echo $_img;
	echo "</A></B></TD>\n<TD WIDTH=\"16%\" class=\"header\"><B>";
	if($GLOBALS["order"]=="type") $new_srt = $_srt;	else $new_srt = "yes";
	echo "<A href=\"".make_link("list",$dir,NULL,"type",$new_srt)."\">".$GLOBALS["messages"]["typeheader"];
	if($GLOBALS["order"]=="type") echo $_img;
	echo "</A></B></TD>\n<TD WIDTH=\"14%\" class=\"header\"><B>";
	if($GLOBALS["order"]=="mod") $new_srt = $_srt;	else $new_srt = "yes";
	echo "<A href=\"".make_link("list",$dir,NULL,"mod",$new_srt)."\">".$GLOBALS["messages"]["modifheader"];
	if($GLOBALS["order"]=="mod") echo $_img;
	echo "</A></B>\n";
	echo "</TD>";
	//echo "<TD WIDTH=\"6%\" class=\"header\"><B>".$GLOBALS["messages"]["actionheader"]."</B></TD>";
	echo "</TR>\n";
	echo "<TR><TD colspan=\"7\"><HR></TD></TR>\n";
		
	// make & print Table using lists
	print_table($dir, make_list($dir_list, $file_list), $allow);

	// print number of items & total filesize
	echo "<TR><TD colspan=\"7\"><HR></TD></TR><TR>\n<TD class=\"header\"></TD><TD class=\"header\"></TD>";
	echo "<TD class=\"header\">".$num_items." ".$GLOBALS["messages"]["miscitems"]." (";
	//if(function_exists("disk_free_space")) {
	//	$free=parse_file_size(disk_free_space(get_abs_dir($dir)));
	//} elseif(function_exists("diskfreespace")) {
	//	$free=parse_file_size(diskfreespace(get_abs_dir($dir)));
	//} else $free="?";
	// echo "Total: ".parse_file_size(disk_total_space(get_abs_dir($dir))).", ";
	$free = parse_file_size($GLOBALS["quota"]-$tot_file_size);
	echo $GLOBALS["messages"]["miscfree"].": ".$free.")</TD>\n";
	echo "<TD class=\"header\">&nbsp;</TD>";
	echo "<TD class=\"header\">&nbsp;</TD>";
	echo "<TD class=\"header\">".parse_file_size($tot_file_size)."</TD>\n";
	$usage=sprintf("%.2f",$tot_file_size/$GLOBALS["quota"]*100);
//	loggear("USAGE: $num_items items, $tot_file_size bytes ($usage%)");
	for($i=0;$i<2;++$i) echo"<TD class=\"header\"></TD>";
	echo "</TR>\n<TR><TD colspan=\"7\"><HR></TD></TR></FORM></TABLE>\n";
	
?><script language="JavaScript1.2" type="text/javascript">
<!--
	// Uncheck all items (to avoid problems with new items)
	var ml = document.selform;
	var len = ml.elements.length;
	for(var i=0; i<len; ++i) {
		var e = ml.elements[i];
		if(e.name == "selitems[]" && e.checked == true) {
			e.checked=false;
		}
	}
// -->
</script><?php
}
//------------------------------------------------------------------------------
?>
